#! /bin/bash
# The top line might need to be changed if your bash executable is located in another directory.


BBCONFFILE=/etc/bashburnrc
BBROOTDIR=$(pwd)

overwrite_selection()
{
while true; do
	echo -n '|> '
	read choice
	if [[ "$choice" = "n" ]]; then
		echo; echo -e "\033[1;31mNot\033[1;0m overwriting config file."; echo
		echo 'Installation finished. Now start BashBurn with the'
		echo -e "command \033[1;36mbashburn\033[1;0m, and remember to"
		echo 'configure it before trying to use it.'; echo
		exit
	else
		break
	fi
done
}

install_files()
{
	echo; echo -n 'Installing files...'
	if [[ ! -e "${BBINSTALL_PATH}" ]]; then # Does the path already exist?
		mkdir ${BBINSTALL_PATH}
	fi
	cp -Rfp * ${BBINSTALL_PATH}
	rm ${BBINSTALL_PATH}/Install.sh		# We don't need the install script lying around
	echo -e "\033[1;32m[DONE]\033[1;0m"; echo

	echo -n 'Creating symlink...'
        cd /usr/local/bin && ln -sf ${BBINSTALL_PATH}/BashBurn.sh bashburn
	echo -e "\033[1;32m[DONE]\033[1;0m"; echo

	if [[ -e ${BBCONFFILE} ]]; then
		echo "Config file found! (${BBCONFFILE}) Do you want to overwrite it? (y/n)"
		overwrite_selection
		echo; echo -n 'Installing config file...'
		cp -f ${BBINSTALL_PATH}/bashburnrc ${BBCONFFILE} 
		cat ${BBCONFFILE} | sed -e "s^BBROOTDIR.*BBROOTDIR: $BBINSTALL_PATH" | cat &> ${BBCONFFILE}
		echo -e "\033[1;32m[DONE]\033[1;0m"
	else
		echo; echo -n 'Installing config file...'
		cp -f ${BBROOTDIR}/bashburnrc ${BBCONFFILE}
		cat ${BBCONFFILE} | sed -e "s^BBROOTDIR.*BBROOTDIR: $BBINSTALL_PATH" | cat &> ${BBCONFFILE}
		echo -e "\033[1;32m[DONE]\033[1;0m"
	fi

	echo; echo 'Do you want regular users to be able to change the global config file?'
	echo 'NOTE: On small systems (Say a computer you and your family uses) this'
	echo 'might be a good idea.'
	overwrite_selection
	echo; echo -n "Adjusting permissions on ${BBCONFFILE}..."
	chmod 666 ${BBCONFFILE}
	echo -e "\033[1;32m[DONE]\033[1;0m"; echo
	echo 'Installation finished. Now start BashBurn with the'
	echo -e "command \033[1;36mbashburn\033[1;0m, and remember to"
	echo 'configure it before trying to use it.'
}


echo
echo 'Installation script for BashBurn 1.3+'
echo

if whoami | grep root > /dev/null ; then
	
	echo 'Where do you want to install BashBurn? (Default is /usr/local/BashBurn)'
	echo 'Just press enter to use the default location.'
	echo -n 'Path: '
	read BBINSTALL_PATH
	if [[ "${BBINSTALL_PATH}" = "" ]]; then
		BBINSTALL_PATH="/usr/local/BashBurn"
		echo "Installing BashBurn into ${BBINSTALL_PATH}"
		sleep 1s
		install_files
	else
		install_files
	fi
else
	echo 'You are not root. Please run this script as root before starting BashBurn'
fi
